uses crt;



function int2str(int:integer):string;
var sint:string;
begin
	str(int, sint);
    int2str:=sint;
end;

procedure asmReset;assembler;
asm
	mov AH,00H
    int 13H
end;

function asmGetError:integer;assembler;
asm
	mov AH,01H
    int 13H

    xor AX,AX
    lea DI,asmGetError
    stosw
end;

function getError(errorCode:integer):string;
var error:string;
begin
	case errorCode of
    	0:error:='';
    	1:error:='⢨⥫쭠 ';
        2:error:=' 㦥  訡筮 ᭮ ';
        3:error:='⪠   饭 ᪥';
        4:error:='  㦥';
        8:error:='訡  DMA-஫';
        9:error:='⪠  DMA  , 祬 64 ';
        16:error:='訡   (CRC)';
        32:error:='訡  ஫';
        64:error:='஦  㦥 (Bad Seek)';
        128:error:=' ⢥  ன⢠ (⠩)';
    else  error:='⭠ 訡';
    end;
    if length(error)>0 then
    	error:='Error ' + int2str(errorCode) + ': ' + error;
    getError:=error;
end;

procedure asmReadSector(deviceNumber, diskSide,trackNumber,firstSectorNumber,sectorsCount:byte;inputBuffer:pointer;
						var error:integer);assembler;
asm
	mov AH,02H
    mov AL,sectorsCount
    mov DL,deviceNumber
    mov DH,diskSide
    mov CL,firstSectorNumber
    mov CH,trackNumber
    mov BX,offset inputBuffer
    int 13H

    jnc @@1

    mov AL,AH
    xor AH,AH
    les DI,error
    stosw
@@1:
end;

const
	deviceNumber=0;
	diskSide	=1;
	sectorsCount=10;

var trackNumber,sectorNumber:byte;
    buffer:string;
    error:string;
    errorCode:integer;
begin
	clrscr;
    writeln('  ஦:');
    readln(trackNumber);
    writeln('  ᥪ:');
    readln(sectorNumber);


    asmReset;

    asmReadSector(deviceNumber,diskSide,trackNumber,sectorNumber,sectorsCount,@buffer,errorCode);
    error:=getError(errorCode);
    if length(error)>0 then
    	writeln(error)
    else
    	writeln(buffer);

    readln;
end.