uses crt;

var rusChars:array[1..102] of char;
	engChars:array[1..102] of char;
    rusLang:boolean;

function int2str(int:integer):string;
var sint:string;
begin
	str(int, sint);
    int2str:=sint;
end;

procedure initRusChars;
begin
	rusChars[16]:='';
    rusChars[17]:='';
	rusChars[18]:='';
	rusChars[19]:='';
    rusChars[20]:='';
    rusChars[21]:='';
	rusChars[22]:='';
    rusChars[23]:='';
    rusChars[24]:='';
    rusChars[25]:='';
    rusChars[26]:='';
    rusChars[27]:='';

    rusChars[30]:='';
    rusChars[31]:='';
    rusChars[32]:='';
    rusChars[33]:='';
    rusChars[34]:='';
    rusChars[35]:='';
    rusChars[36]:='';
    rusChars[37]:='';
    rusChars[38]:='';
    rusChars[39]:='';
    rusChars[40]:='';
    rusChars[41]:='';

    rusChars[44]:='';
    rusChars[45]:='';
    rusChars[46]:='';
    rusChars[47]:='';
    rusChars[48]:='';
    rusChars[49]:='';
    rusChars[50]:='';
    rusChars[51]:='';
    rusChars[52]:='';
end;

procedure initEngChars;
begin
	engChars[16]:='q';
    engChars[17]:='w';
	engChars[18]:='e';
	engChars[19]:='r';
    engChars[20]:='t';
    engChars[21]:='y';
	engChars[22]:='u';
    engChars[23]:='i';
    engChars[24]:='o';
    engChars[25]:='p';

    engChars[30]:='a';
    engChars[31]:='s';
    engChars[32]:='d';
    engChars[33]:='f';
    engChars[34]:='g';
    engChars[35]:='h';
    engChars[36]:='j';
    engChars[37]:='k';
    engChars[38]:='l';

    engChars[44]:='z';
    engChars[45]:='x';
    engChars[46]:='c';
    engChars[47]:='v';
    engChars[48]:='b';
    engChars[49]:='n';
    engChars[50]:='m';
end;

procedure asmReadChar(var posChar,codeChar);assembler;
asm
	mov AH,00H
    int 16H
    push AX
    xor AH,AH
	les	DI,codeChar
    stosw

    pop AX
    mov AL,AH
    xor AH,AH
    les	DI,posChar
    stosw
end;

function _asmIsCharEnabled:integer;assembler;
asm
	mov AH,01H
    int 16H
    jz  @@1
    xor AH,AH
    mov AL,01H
    ret
@@1:xor AH,AH
	mov AL,00H
    ret

end;

function isCharEnabled:boolean;
var charEnabled:integer;
begin
    charEnabled:=_asmIsCharEnabled;
	{writeln('charEnabled = '+int2str(charEnabled));}
	isCharEnabled:=charEnabled<>0;
end;

function _asmIsCtrlShift:integer;assembler;
asm
	mov AH,02H
    int 16H
    and AL,6H
    cmp AL,6H
    jz  @@1
    mov AL,00H
    ret
@@1:mov AL,01H
	ret

end;

function isCtrlShift:boolean;
begin
   	isCtrlShift:=_asmIsCtrlShift<>0;
end;

procedure _drawWindow(x1,y1,x2,y2,bgcolor,txtcolor:integer);
begin
	window(x1,y1,x2,y2);
    textBackGround(bgcolor);
    textColor(txtcolor);
    clrscr;
end;

procedure _drawLangWindow(rusLang:boolean);
begin
	_drawWindow(75,1,80,1,red,black);
    if rusLang then
    	write('rus')
    else
    	write('eng');
end;

procedure _drawMainWindow;
begin
	_drawWindow(1,1,59,25,black,lightgray);
end;

procedure _drawAllWindows(rusLang:boolean);
begin
    textBackGround(black);
    clrscr;
    _drawLangWindow(rusLang);
    _drawMainWindow;
end;


procedure writeChar(codeChar, posChar:integer);
var currentChar:char;
begin
	if rusLang then
    	currentChar:=rusChars[posChar]
    else
    	currentChar:=engChars[posChar];
    if currentChar<>#0 then
    begin
		write(int2str(codeChar)+' - '+int2str(posChar)+' = ');
		write('"');
	    write(currentChar);
		writeln('"');
    end;
end;


const Esc=27;
var codeChar, posChar:integer;

begin
    initRusChars;
    initEngChars;
    rusLang:=false;
    _drawAllWindows(rusLang);
    repeat
        repeat
        	if isCtrlShift then
                begin
            		rusLang:= not rusLang;
                    _drawAllWindows(rusLang);
                    repeat
                    until not isCtrlShift;
                end;
        until isCharEnabled;

		asmReadChar(posChar, codeChar);

        writeChar(codeChar, posChar);
    until codeChar=Esc;
end.