uses crt;

procedure asmSetVGAMode(mode:integer);assembler;
asm
	mov AH,4fH
    mov AL,02H
    mov BX,mode
    int 10H
end;

procedure asmGetCurrentVGAMode(var mode:integer);assembler;
asm
	mov AH,4fH
    mov AL,03H
    int 10H

    mov AX,BX
    les DI,mode
    stosw
end;

procedure asmPutPixel(x,y,color:integer);assembler;
asm
	mov DX,y
    mov CX,x
    mov AL,byte ptr color
    mov AH,0cH
    int 10H

end;


procedure drawCircle(x,y,r,color:integer);
var i:integer;
begin
	for i:=0 to 360 do
       	asmPutPixel(x+round(cos(i/180*pi)*r),y+round(sin(i/180*pi)*r),color);
end;

const n=10;
var currentMode:integer;
	x,y,r:integer;
    i:integer;

begin
	x:=n*15;
    y:=n*10;
    r:=n*8;
	asmGetCurrentVGAMode(currentMode);
    asmSetVGAMode(94);{94 - 1024x768x?}
	drawCircle(x,y,r,2);
	readln;
    asmSetVGAMode(currentMode);
end.